module Til
  class NoteList
    include Thor::Base
    include Thor::Actions
    attr_accessor :notes

    def initialize(notes=Array.new)
      @notes = notes
    end

    def to_note_list
      self
    end

    def sort_by_modified_time
      NoteList.new(notes.sort { |a, b| b.mtime <=> a.mtime })
    end

    def most_recent
      notes.sort { |a, b| b.mtime <=> a.mtime }.fetch(0)
    end

    def filter
      if notes.length == 1
        notes.first
      else
        notes.each_with_index do |note, index|
          puts "#{index+1}) #{note.title.bold} (#{note.subject})"
        end
      
        begin
          choice = ask("Choice: ").to_i
        rescue Interrupt
          warn "\nAborted!"
          abort
        end

        notes.fetch(choice-1) do
          puts "Invalid choice!"
          abort
        end
      end
    end

    def method_missing(m, *args, &block)
      notes.send(m, *args, &block)
    end
  end
end
