require 'pathname'

module Til
  class Settings
    attr_reader :settings, :settings_file_path

    def self.load
      @settings_file_path = File.expand_path("~/.til.config")
      if File.exist?(@settings_file_path)
        self.new(@settings_file_path)
      else
        puts "You don't appear to have a settings file! Configuring one now.".red
        Initializer.new.create_settings_file(@settings_file_path)
        self.new(@settings_file_path)
      end
    end

    def directory
      File.expand_path(settings["directory"])
    end

    def github_repo
      settings["github_repo"]
    end

    def editor
      settings["editor"] || ENV["VISUAL"] || ENV["EDITOR"] || "vim"
    end

    private

    def initialize(config_file)
      @settings = JSON.parse(File.read(config_file))
    end
  end
end
