module Til
  class NoteDisplayer
    attr_accessor :notes

    HIGHLIGHT_COLORS = {
        0 => :yellow,
        1 => :light_blue,
        2 => :green,
        3 => :blue,
        4 => :red,
        5 => :magenta,
        6 => :light_magenta,
      }

    def initialize notes
      @notes = notes.to_note_list
    end

    def print
      notes.each do |note|
        puts note.subject.underline + ": " + note.title.bold + " (" + note.pretty_printed_mtime + ")"
        puts note.content
      end
    end

    def list
      subjects_seen = Array.new
      longest_subject_length = notes.sort_by{|note| note.subject.length}.last.subject.length
      notes.each do |note|
        subjects_seen.push(note.subject) if !subjects_seen.include?(note.subject)
        color_index = subjects_seen.index(note.subject) % HIGHLIGHT_COLORS.length
        color = HIGHLIGHT_COLORS[color_index]
        spacing = " " * (longest_subject_length - note.subject.length)
        puts note.subject.colorize(color) + ": " + spacing + note.title.bold + " (" + note.pretty_printed_mtime + ")"
      end
    end

  end
end
